/**
 * @license
 *-------------------------------------------------------------------------------------------
 * Copyright © 2025 Progress Software Corporation. All rights reserved.
 * Licensed under commercial license. See LICENSE.md in the package root for more information
 *-------------------------------------------------------------------------------------------
 */
"use client";
"use strict";Object.defineProperty(exports,Symbol.toStringTag,{value:"Module"});const Ot=require("react"),b=require("@progress/kendo-react-common"),d=require("@progress/kendo-react-data-tools"),Lt=require("./drag/ColumnResize.js"),zt=require("./drag/CommonDragLogic.js"),Ft=require("./constants/index.js"),A=require("./utils/index.js"),Nt=require("./VirtualScroll.js"),qt=require("./contextMenu/GridContextMenu.js"),Le=require("./contextMenu/enums.js"),ze=require("./sortCommon.js"),Ut=require("./BasePDFExport.js"),Vt=require("./utils/GridContext.js"),Wt=require("./filterCommon.js");function Bt(t){const I=Object.create(null,{[Symbol.toStringTag]:{value:"Module"}});if(t){for(const g in t)if(g!=="default"){const L=Object.getOwnPropertyDescriptor(t,g);Object.defineProperty(I,g,L.get?L:{enumerable:!0,get:()=>t[g]})}}return I.default=t,Object.freeze(I)}const a=Bt(Ot),jt=t=>{const I=t.gridProps.isClient,[g,L]=a.useState({}),Ce=b.useAdaptiveModeContext(),Ie=a.useRef(null),Fe=e=>{e.event.preventDefault(),L({...g,show:!0,offset:{left:e.event.pageX,top:e.event.pageY},dataItem:e.dataItem,field:e.field})},Ee=()=>{L({})},R=a.useMemo(()=>t.columnsRef.find(e=>e.field===g.field),[t.columnsRef,g]),we=a.useMemo(()=>{const e=t.gridProps.sortable&&(R==null?void 0:R.sortable);return A.getDefaultHeadContextMenuItems({pdf:!!t.gridProps.pdf,sortable:!!e,selectable:d.getSelectionOptions(t.gridProps.selectable).enabled,clipboard:!!t.gridProps.clipboard})},[R,t.gridProps.sortable,t.gridProps.selectable,t.gridProps.clipboard]),ye=a.useMemo(()=>{const e=t.gridProps.sortable&&(R==null?void 0:R.sortable);return A.getDefaultBodyContextMenuItems({pdf:!!t.gridProps.pdf,sortable:!!e,selectable:d.getSelectionOptions(t.gridProps.selectable).enabled,clipboard:!!t.gridProps.clipboard,rowReorderable:A.isRowReorderEnabled(t.gridProps.rowReorderable)})},[R,t.gridProps.sortable,t.gridProps.selectable,t.gridProps.clipboard]),$=a.useMemo(()=>{const e=(R==null?void 0:R.contextMenu)||t.gridProps.contextMenu,n=typeof e=="function"?e(g):e;if(n&&g.offset){const o=g.dataItem?Le.GridContextMenuAnchorPart.body:Le.GridContextMenuAnchorPart.head,r=n[o],i=g.dataItem?ye:we;return r===!1?void 0:r===!0||r===void 0?i:r}},[t.gridProps.contextMenu,g,ye,we,R]),Ne=e=>{var l,u,f,h,w,re,C,B,j;const n=e.event.item,o={target:E.current,syntheticEvent:e.event.syntheticEvent,nativeEvent:e.event.nativeEvent,menuItem:n,...e};t.gridProps.onContextMenuItemClick&&s(t.gridProps.onContextMenuItemClick,o);const r=y(),i={selectedField:"",componentId:t.id,dataItems:r,dataItem:e.dataItem,startRowIndex:-1,endRowIndex:-1,startColIndex:-1,endColIndex:-1,ctrlKey:!1,altKey:!1,metaKey:!1,shiftKey:!1,isDrag:!1,...d.getSelectionOptions(t.gridProps.selectable),...o},c=r.findIndex(_=>_===e.dataItem);switch((l=n.data)==null?void 0:l.action){case"SortCommand":if(R){const _=(u=n.name)==null?void 0:u.toLowerCase().includes("asc"),At=((f=n.name)==null?void 0:f.toLowerCase().includes("desc"))?"desc":void 0,Gt=_?"asc":At,Ht=n.name?Gt:void 0;Se(e.event.syntheticEvent,R,Ht)}break;case"SelectRowCommand":ot(i);break;case"SelectAllRowsCommand":rt(i);break;case"ExportPDFCommand":oe();break;case"ClearSelectionCommand":it(i);break;case"ReorderRowCommand":W.current=e.dataItem,(h=n.name)!=null&&h.toLowerCase().includes("rowup")&&c>0&&F(e.event.syntheticEvent,c-1,"before"),(w=n.name)!=null&&w.toLowerCase().includes("rowdown")&&c<r.length-1&&F(e.event.syntheticEvent,c+1,"after"),(re=n.name)!=null&&re.toLowerCase().includes("rowtop")&&F(e.event.syntheticEvent,0,"before"),(C=n.name)!=null&&C.toLowerCase().includes("rowbottom")&&F(e.event.syntheticEvent,r.length-1,"after");break;case"CopySelectionCommand":Q(d.ClipboardActionType.copy,e.event.nativeEvent,{copyHeaders:!((B=n.name)!=null&&B.toLowerCase().includes("noheaders"))},e.dataItem,e.field);break;case"PasteCommand":Q(d.ClipboardActionType.paste,e.event.nativeEvent,{copyHeaders:!((j=n.name)!=null&&j.toLowerCase().includes("noheaders"))},e.dataItem,e.field);break}Ee()},X=()=>{const e=t.columnsRef.filter(n=>n.declarationIndex>=0&&n.parentIndex===-1);return A.sanitizeColumns(e)},qe=(e,n,o)=>{if(t.gridProps.onContextMenu&&I){const r={target:E.current,syntheticEvent:e,nativeEvent:e.nativeEvent,dataItem:n,field:o};s(t.gridProps.onContextMenu,r)}t.gridProps.contextMenu&&Fe({event:e,dataItem:n,field:o})},Ue=e=>{if(e.target!==e.currentTarget)return;clearTimeout(he.current),P.current&&(P.current.table=M.current);const n=e.currentTarget.scrollLeft,o=e.currentTarget.scrollTop;t.gridProps.columnVirtualization&&(!D||o===Pe.current)&&(he.current=window.setTimeout(()=>{N()},0)),t.gridProps.scrollLeftRef&&(t.gridProps.scrollLeftRef.current=n),V.current&&V.current.setScrollLeft(n),U.current&&U.current.setScrollLeft(n),P.current&&o!==Pe.current&&P.current.scrollHandler(e),t.gridProps.onScroll&&I&&s(t.gridProps.onScroll,{...m(e)}),Pe.current=o},Ve=e=>{d.tableKeyboardNavigation.onKeyDown(e,{navigatable:t.gridProps.navigatable||!1,contextStateRef:K,navigationStateRef:G,onNavigationAction:Be,columns:X()}),d.tableKeyboardNavigation.onGetSnapshotBeforeUpdate({document:S(),contextStateRef:K,navigationStateRef:G});const n={dataItems:y(),mode:v.mode,cell:v.cell,componentId:t.id,selectedField:"",...m(e)};t.gridProps.onKeyDown&&I&&s(t.gridProps.onKeyDown,n)},We=e=>{d.tableKeyboardNavigation.onFocus(e,{navigatable:!!t.gridProps.navigatable,contextStateRef:K})},Be=e=>{if(e.action==="moveToNextPage"&&lt(e.event),e.action==="moveToPrevPage"&&st(e.event),e.focusElement&&e.action==="reorderToRight"){const n=parseInt(e.focusElement.ariaColIndex,10)-1;n<t.columnsRef.length-1&&ce(n,n+1,e.event)}if(e.focusElement&&e.action==="reorderToLeft"){const n=parseInt(e.focusElement.ariaColIndex,10)-1;n>0&&ce(n,n-1,e.event)}if(e.action==="select"&&et(e.event),t.gridProps.onNavigationAction&&I){const n={focusElement:e.focusElement,...m(e.event)};s(t.gridProps.onNavigationAction,n)}},je=(e,n)=>{t.gridProps.onRowClick&&e.target.nodeName==="TD"&&s(t.gridProps.onRowClick,{dataItem:n,...m(e)})},_e=(e,n)=>{t.gridProps.onRowDoubleClick&&e.target.nodeName==="TD"&&s(t.gridProps.onRowDoubleClick,{dataItem:n,...m(e)})},$e=e=>{t.gridProps.onItemChange&&s(t.gridProps.onItemChange,{...m(e.syntheticEvent),dataItem:e.dataItem,field:void 0,value:void 0})},Xe=e=>{t.gridProps.onItemChange&&t.gridProps.onEditChange&&s(t.gridProps.onEditChange,{edit:{},...m(e.syntheticEvent)})},Je=(e,n,o)=>{if(Oe.enabled&&Oe.mode==="incell"&&t.gridProps.dataItemKey){const r=d.editReducer(t.gridProps.edit,{type:d.EDIT_ACTION.ENTER_FIELD_EDIT,payload:{id:n[t.gridProps.dataItemKey],field:o}});t.gridProps.onEditChange&&s(t.gridProps.onEditChange,{edit:r,...m(e)})}},Ye=(e,n)=>{var r;if(d.getDetailExpandableOptions(t.detailExpandable).enabled){const i=d.detailExpandReducer((r=t.gridProps.detailExpand)!=null?r:{},e);t.gridProps.onDetailExpandChange&&s(t.gridProps.onDetailExpandChange,{...m(n),detailExpand:i})}},Qe=(e,n)=>{var r;const o=d.getGroupExpandableOptions(typeof t.gridProps.groupable=="object"?t.gridProps.groupable.expandable!==!1:t.gridProps.groupable);if(o.enabled){const i=d.groupExpandReducer((r=t.gridProps.groupExpand)!=null?r:[],e,o);t.gridProps.onGroupExpandChange&&s(t.gridProps.onGroupExpandChange,{...m(n),groupExpand:i})}},Se=(e,n,o)=>{const{allowUnsort:r,mode:i}=ze.normalizeSortable(t.gridProps.sortable||!1,n.sortable||!1),c=(t.gridProps.sort||[]).filter(f=>f.field===n.field)[0],l=o||ze.firstLevelSortSeqMap[r][c&&c.dir||""],u=i==="single"?[]:(t.gridProps.sort||[]).filter(f=>f.field!==n.field);l!==""&&n.field&&u.push({field:n.field,dir:l}),xe(u,e)},Ze=e=>{t.gridProps.onItemChange&&s(t.gridProps.onItemChange,{...m(e.syntheticEvent),dataItem:e.dataItem,dataIndex:e.dataIndex,field:e.field,value:e.value})},pe=e=>{var n;if(t.gridProps.onSelectionChange&&v.enabled){const{event:o,dataItem:r,dataIndex:i,columnIndex:c}=e,l={...m(o),dataItem:r,startColIndex:c,endColIndex:c,startRowIndex:i,endRowIndex:i,dataItems:y(),altKey:!1,ctrlKey:!1,shiftKey:!1,metaKey:!1,mode:v.mode,cell:v.cell,isDrag:!1,componentId:t.id,selectedField:""};s(t.gridProps.onSelectionChange,{...l,select:t.gridProps.dataItemKey?d.getSelectedState({event:l,selectedState:(n=t.gridProps.select)!=null?n:{},dataItemKey:t.gridProps.dataItemKey}):{}})}},et=e=>{var f,h;if(!v.enabled||!t.gridProps.dataItemKey)return;const n={dataItems:y(),mode:v.mode,cell:v.cell,componentId:t.id,selectedField:"",...m(e)},o=d.getSelectedStateFromKeyDown({event:n,selectedState:(f=t.gridProps.select)!=null?f:{},dataItemKey:t.gridProps.dataItemKey});if(o===t.gridProps.select)return;const r=e.target,i=d.closestTagName(r,"TD"),c=d.closestTagName(r,"TR"),l=d.getColumnIndex(i),u=d.getRowIndex(c);if(l!==void 0&&u!==void 0){const w=(h=A.getDataAsArray(t.gridProps.data))==null?void 0:h[u];t.gridProps.onSelectionChange&&s(t.gridProps.onSelectionChange,{...n,select:o,dataItem:w,startRowIndex:u,startColIndex:l,startDataItem:w,endDataItem:w,endRowIndex:u,endColIndex:l,ctrlKey:e.ctrlKey,altKey:e.altKey,metaKey:e.metaKey,shiftKey:e.shiftKey,isDrag:!1})}},tt=e=>{if(t.gridProps.onHeaderSelectionChange&&v.enabled){const n=y();s(t.gridProps.onHeaderSelectionChange,{select:e.syntheticEvent.target.checked?n.reduce((o,r)=>(t.gridProps.dataItemKey&&b.getter(t.gridProps.dataItemKey)(r)!==void 0&&(o[b.getter(t.gridProps.dataItemKey)(r)]=!0),o),{}):{},field:e.field,nativeEvent:e.syntheticEvent&&e.syntheticEvent.nativeEvent,syntheticEvent:e.syntheticEvent,target:E.current,dataItems:n})}},J=(e,n)=>{t.gridProps.onSelectionChange&&v.enabled&&s(t.gridProps.onSelectionChange,{...e,select:n})},nt=e=>{var n;if(t.gridProps.onSelectionChange&&v.enabled){const o=y()[e.startRowIndex],r=y()[e.endRowIndex],i={syntheticEvent:void 0,target:E.current,selectedField:"",componentId:t.id,dataItems:y(),dataItem:null,startDataItem:o,endDataItem:r,...e},c=d.getSelectedState({event:i,selectedState:(n=t.gridProps.select)!=null?n:{},dataItemKey:t.gridProps.dataItemKey});J(i,c)}},rt=e=>{if(t.gridProps.onSelectionChange&&v.enabled){const n=e.dataItems[0],o=e.dataItems[e.dataItems.length-1],r={},i={...e,startDataItem:n,endDataItem:o,startRowIndex:0,endRowIndex:e.dataItems.length-1,startColIndex:0,endColIndex:t.columnsRef.length-1};e.dataItems.forEach(c=>{const u=b.getter(t.gridProps.dataItemKey)(c);r[u]=e.cell?[...Array(t.columnsRef.length).keys()]:!0}),J(i,r)}},ot=e=>{if(t.gridProps.onSelectionChange&&v.enabled){const o=b.getter(t.gridProps.dataItemKey)(e.dataItem),r=0,i=t.columnsRef.length-1,c=e.dataItems.findIndex(w=>w[t.gridProps.dataItemKey]===e.dataItem[t.gridProps.dataItemKey]),f={...e,startDataItem:c,endDataItem:c,startRowIndex:c,endRowIndex:c,startColIndex:r,endColIndex:i},h=e.mode==="multiple"?t.gridProps.select||{}:{};h[o]===!0||Array.isArray(h[o])&&h[o].length===t.columnsRef.length?delete h[o]:h[o]=e.cell?[...Array(t.columnsRef.length).keys()]:!0,J(f,h)}},it=e=>{t.gridProps.onSelectionChange&&v.enabled&&J(e,{})},z=(e,n,o,r,i)=>{dt();const c=t.gridProps.onDataStateChange;if(e){const l={...m(r),...n,targetEvent:i};s(e,l)}else c&&s(c,{...m(r),targetEvent:i||{},dataState:{...Ct(),...o}})},Y=(e,n,o)=>{var r;D&&t.gridProps.pageable&&((r=P.current)==null||r.reset()),z(t.gridProps.onPageChange,{page:e},{skip:e.skip,take:e.take},n,o)},at=(e,n,o)=>{var r;t.gridProps.pageable||(r=t.gridProps.group)!=null&&r.length?t.gridProps.virtualSkipRef&&(t.gridProps.virtualSkipRef.current=e.skip,N()):Y(e,n,o)},ct=()=>{let e=t.gridProps.total||0;return Array.isArray(t.gridProps.data)?e=e||t.gridProps.data.length:t.gridProps.data&&(e=e||t.gridProps.data.total),e},dt=()=>{D&&t.gridProps.virtualSkipRef&&(t.gridProps.virtualSkipRef.current=0)},lt=e=>{var i,c;const n=(c=(i=t.gridProps.take)!=null?i:t.gridProps.pageSize)!=null?c:0,o=(t.gridProps.skip||0)+n,r=ct();o<r&&Y({skip:o,take:n},e)},st=e=>{var r,i;const n=(i=(r=t.gridProps.take)!=null?r:t.gridProps.pageSize)!=null?i:0,o=(t.gridProps.skip||0)-n;o>=0&&Y({skip:o,take:n},e)},ut=e=>{Y({skip:e.skip,take:e.take},e.syntheticEvent,e.targetEvent)},xe=(e,n)=>{z(t.gridProps.onSortChange,{sort:e},{sort:e,...D&&!t.gridProps.pageable?{skip:0}:{}},n)},gt=(e,n)=>{z(t.gridProps.onFilterChange,{filter:e},{filter:e,skip:0},n)},ft=e=>{const n=t.gridProps.searchFields||t.columnsRef.map(i=>i.field)||[],o=e.nativeEvent.target.value,r={logic:"or",filters:n.filter(i=>i!==void 0).map(i=>{var c;return typeof i=="string"?{field:i,value:o,operator:"contains"}:{value:o,operator:(c=i.operator)!=null?c:"contains",field:i.field,ignoreCase:i.ignoreCase}})};z(t.gridProps.onSearchChange,{search:r},{},e.syntheticEvent)},oe=()=>{var e;(e=Ie.current)==null||e.save()},mt=async e=>{var n,o;(n=t.gridProps)!=null&&n.onPdfExport&&await((o=t.gridProps)==null?void 0:o.onPdfExport(e))},ie=(e,n)=>{const o=n.nativeEvent?n:{nativeEvent:n.nativeEvent||n.originalEvent};let r={};t.isVirtualScroll&&e.length&&!t.gridProps.pageable&&(r={take:void 0}),e.length===0&&t.gridProps.navigatable&&(ge.current=!0),z(t.gridProps.onGroupChange,{group:e},{group:e,skip:0,...r},o)},ae=e=>{if(t.gridProps.onColumnsStateChange){const n={target:E.current,columnsState:e};s(t.gridProps.onColumnsStateChange,n)}},ce=(e,n,o)=>{const{columnsRef:r,columnsState:i}=t,c=r[e],l=A.getFlatColumnsState(i),u=c.depth,f=C=>{do C++;while(C<r.length&&r[C].depth>u);return C},h=r.splice(e,f(e)-e);r.splice(e<n?f(n-h.length):n,0,...h),r.filter(C=>C.declarationIndex>=0).forEach((C,B)=>{C.orderIndex=B;const j=l.find(_=>_.id===C.id);j&&(j.orderIndex=B)});const w=r[e].locked&&r[n].locked;d.updateLeft(t.columnsMapRef,r,w||te.current),d.updateRight(t.columnsMapRef,r,w||te.current),ue.current&&(te.current=!1,ue.current=!1);const re=X();if(N(),t.gridProps.onColumnReorder){const C={target:E.current,columns:re,columnId:c.id,nativeEvent:o};s(t.gridProps.onColumnReorder,C)}ae(i)},F=(e,n,o)=>{const r=typeof t.gridProps.rowReorderable=="object"?t.gridProps.rowReorderable.enabled:t.gridProps.rowReorderable;if(o==="forbidden"||!r||!W.current)return;const i=t.dataRef[n];t.gridProps.onRowReorder&&s(t.gridProps.onRowReorder,{draggedDataItems:[W.current],droppedDataItem:i==null?void 0:i.dataItem,dropPosition:o,nativeEvent:e.originalEvent,dragEvent:e,target:E.current}),W.current=null},Pt=(e,n,o)=>{if(t.gridProps.group===void 0)return;const r=t.gridProps.group.slice();r.splice(n,0,...r.splice(e,1)),ie(r,o)},De=(e,n,o)=>{const r=t.columnsRef[e].field;if(!r)return;const i=(t.gridProps.group||[]).slice();i.splice(n,0,{field:r}),ie(i,o)},ht=(e,n)=>{const o=k.current.getCurrentGroupsLength;De(e,o,n)},de=()=>{let e=0;if(!x.current.colGroupMain)return;const n=x.current.colGroupMain.children;for(let o=0;o<n.length;o++){const r=n[o].width;if(!r){e=0;break}e+=parseFloat(r.toString())}e=Math.round(e),V.current&&V.current.setWidth(e),U.current&&U.current.setWidth(e),M.current&&(M.current.style.width=e?e+"px":"")},ke=()=>{var e;t.gridProps.widthRef&&(t.gridProps.widthRef.current=((e=T.current)==null?void 0:e.offsetWidth)||0)},Ke=()=>{var e;t.gridProps.containerHeightRef&&(t.gridProps.containerHeightRef.current=((e=q.current)==null?void 0:e.offsetHeight)||0)},bt=()=>{const e=t.gridProps.minRowHeightRef;if(e&&!e.current&&!t.gridProps.rowHeight){const n=A.calcRowHeight(O.current);n&&(e.current=n,N())}},Q=a.useCallback((e,n,o,r,i)=>{var f;if(!Rt()&&!o||!e)return;const c={type:e,nativeEvent:n,columns:t.columnsRef,dataItemKey:t.gridProps.dataItemKey||"",dataItem:r,field:i,...typeof t.gridProps.clipboard!="boolean"?t.gridProps.clipboard:{},...o},l=y(),u=d.populateClipboardData({event:c,data:l,selectedState:(f=t.gridProps.select)!=null?f:{},previousCopiedItems:Ge.current});e!==d.ClipboardActionType.paste&&(Ge.current=u.copiedItems),t.gridProps.onClipboard&&I&&s(t.gridProps.onClipboard,{...c,...u})},[t.gridProps.select,t.gridProps.dataItemKey,t.gridProps.data,t.gridProps.clipboard,t.gridProps.onClipboard]),Rt=()=>{var i,c,l;if(!b.canUseDOM)return!1;const e=b.getActiveElement(S()),n=e?e.matches(".k-table-td")?e:(i=S())==null?void 0:i.body:(c=S())==null?void 0:c.body,o=n.closest(".k-grid-container"),r=n&&((l=T.current)==null?void 0:l.contains(n));return!!(n&&r&&o)},vt=(e,n,o,r,i,c,l)=>{de(),te.current=!0,ue.current=!0,t.gridProps.onColumnResize&&I&&s(t.gridProps.onColumnResize,{columns:X(),nativeEvent:r,targetColumnId:l,index:e,newWidth:n,oldWidth:o,end:i,target:E.current}),i&&ae(c)},Ct=()=>{var e;return{filter:t.gridProps.filter,sort:t.gridProps.sort,skip:t.gridProps.skip,take:(e=t.gridProps.take)!=null?e:t.gridProps.pageSize,group:t.gridProps.group}},m=e=>({nativeEvent:e&&e.nativeEvent,syntheticEvent:e,target:E.current}),It=e=>({...e,nativeEvent:void 0,syntheticEvent:void 0,target:void 0,targetEvent:void 0,focusElement:void 0}),s=(e,n)=>{if(t.gridProps.isClient){e(n);return}e(It(n))},Et=()=>{var e,n,o;if(O.current&&((e=O.current)==null?void 0:e.getElementsByClassName("k-grid-edit-row").length)>0){me.current=!1,(n=document.activeElement)!=null&&n.closest(".k-grid-edit-row")?fe.current=document.activeElement:fe.current=void 0;const r=Array.from((o=O.current)==null?void 0:o.getElementsByClassName("k-grid-edit-row"));r.length>Re.current.length?ee.current=r.filter(i=>!Re.current.includes(i))[0]:r.length===1&&(ee.current=r[0],me.current=!0),Re.current=r}},y=()=>t.dataRef.filter(e=>e.rowType==="data").map(e=>e.dataItem),S=()=>{var e;if(b.canUseDOM)return((e=Z())==null?void 0:e.ownerDocument)||document},Z=()=>T.current,le=a.useCallback(e=>{var r,i;if(!P.current||!((r=P.current)!=null&&r.container)||t.gridProps.scrollable==="none")return;H.current&&H.current.disconnect();const{rowIndex:n}=e,o=Z();if(D){const c=((i=P.current.rowHeightService)==null?void 0:i.offset(n))||0;P.current.container.scroll(0,c)}else if(o){const c=n<1?o.querySelector("tbody > tr:nth-child(1)"):o.querySelector(`tbody > tr:nth-child(${n+1})`);c&&q.current&&(q.current.scrollTop=c.offsetTop)}},[t.gridProps.scrollable]),Me=e=>JSON.stringify(e.map(n=>({id:n.id,field:n.field,title:n.title,children:n.children}))),wt=()=>Me(Mt)===Me(t.columnsRef),yt=()=>{ne.current=window.innerWidth,wt()||N()},St=()=>{var c;const{virtualTotal:e,virtualPageSize:n,gridProps:o}=t,r=P.current,i=t.gridProps.rowHeight||((c=o.minRowHeightRef)==null?void 0:c.current)||0;r&&(r.fixedScroll=o.fixedScroll||!1,r.PageChange=at,r.pageSize=n,r.scrollableVirtual=D,r.container=q.current,r.tableBody=O.current,r.scrollHeightContainer=Ae.current,r.table=M.current,(!r.rowHeightService||r.total!==e)&&i&&(r.total=e,r.rowHeightService=new b.RowHeightService(e,i)))},Te=a.useCallback(e=>{const n={rowIndex:be.current};e.forEach(o=>{o.boundingClientRect.height!==o.intersectionRect.height&&le(n)})},[le]),N=()=>{t.gridProps.forceUpdate&&t.gridProps.forceUpdate()},xt=e=>e.left!==void 0?ve!=="rtl"?{left:e.left,right:e.right}:{left:e.right,right:e.left}:{},E=a.useRef(null),P=a.useRef(void 0),x=a.useRef(void 0),k=a.useRef(void 0),K=a.useRef(void 0),G=a.useRef(void 0),p=a.useRef(void 0),H=a.useRef(null),O=a.useRef(null),Dt=a.useRef(null),q=a.useRef(null),M=a.useRef(null),se=a.useRef(null),T=a.useRef(null),Ae=a.useRef(null),U=a.useRef(null),V=a.useRef(null),ue=a.useRef(!1),ge=a.useRef(!1),ee=a.useRef(void 0),fe=a.useRef(void 0),me=a.useRef(!1),te=a.useRef(!0),Pe=a.useRef(0),he=a.useRef(void 0),be=a.useRef(void 0),Re=a.useRef([]),Ge=a.useRef([]),ne=a.useRef(0),W=a.useRef(null),kt=a.useRef(null),Kt=a.useRef(null),ve=b.useDir(T),D=t.isVirtualScroll,Mt=a.useMemo(()=>a.Children.toArray(t.gridProps.children),[t.gridProps.children]),He=t.gridProps.groupable===!0||typeof t.gridProps.groupable=="object"&&t.gridProps.groupable.enabled!==!1,v=d.getSelectionOptions(t.gridProps.selectable),Oe=d.getEditableOptions(t.gridProps.editable),Tt=ne.current&&Ce&&ne.current<=Ce.medium&&t.gridProps.adaptive;return a.useMemo(()=>{d.tableKeyboardNavigation.onConstructor({navigatable:!!t.gridProps.navigatable,contextStateRef:K,navigationStateRef:G,idPrefix:t.id}),P.current=new Nt.VirtualScroll},[]),a.useMemo(()=>{var e;(e=P.current)==null||e.reset()},[t.gridProps.scrollable,t.gridProps.total,t.gridProps.filter,t.gridProps.group,He,t.gridProps.sort,t.gridProps.rowHeight]),a.useEffect(()=>(t.gridProps.clipboard&&(p.current=new d.ClipboardService(Q),p.current.addEventListeners(S())),()=>{p.current&&p.current.removeEventListeners(S())}),[t.gridProps.onClipboard,t.gridProps.clipboard,Q,S]),a.useEffect(()=>(t.gridProps.columnVirtualization&&!window.navigator.userAgent.match(Ft.SAFARI_REGEX)&&(se.current&&(se.current.style.display="block"),M.current&&(M.current.style.display="block")),ke(),de(),b.setScrollbarWidth(),d.tableKeyboardNavigation.onComponentDidMount({scope:T.current||void 0,contextStateRef:K,navigationStateRef:G}),()=>{clearTimeout(he.current)}),[]),a.useEffect(()=>{var e;ke(),de(),b.setScrollbarWidth(),D&&(Ke(),bt(),(e=P.current)==null||e.update()),Et(),d.tableKeyboardNavigation.onComponentDidUpdate({scope:T.current||void 0,contextStateRef:K,navigationStateRef:G,focusFirst:ge.current,newEditableRow:ee.current,singleEditRow:me.current,lastActiveElement:fe.current,navigatable:t.gridProps.navigatable}),ge.current=!1,ee.current=void 0}),a.useEffect(()=>{if(b.canUseDOM){const e={rootMargin:"0px",threshold:.9};H.current=window.IntersectionObserver&&new window.IntersectionObserver(Te,e)||null}},[Te]),a.useEffect(()=>{var n;let e;return b.canUseDOM&&window.ResizeObserver&&(e=new window.ResizeObserver(()=>{yt(),D&&Ke()}),e.observe((n=S())==null?void 0:n.body)),()=>{e==null||e.disconnect()}},[]),a.useImperativeHandle(E,()=>({get element(){return Z()},props:t.gridProps,get columns(){return X()},scrollIntoView:e=>{var r;if(!((r=P.current)!=null&&r.container)||t.gridProps.scrollable==="none")return;const{rowIndex:n}=e;be.current=n;const o=Z();if(H.current&&o){H.current.disconnect();const i=o.querySelector(`[absolute-row-index="${be.current}"]`);i?H.current.observe(i):le(e)}},fitColumns:e=>{x.current.dblClickHandler(null,e)},exportAsPdf:oe})),a.useImperativeHandle(t.gridRef,()=>E.current),a.useMemo(()=>{x.current=new Lt.ColumnResize(vt)},[t.gridProps.onColumnResize,t.columnsRef]),a.useMemo(()=>{k.current=new zt.CommonDragLogic(ce,Pt,De)},[t.gridProps.onColumnReorder,t.gridProps.onGroupChange,t.gridProps.group,t.columnsRef,t.gridProps.groupable]),x.current.resizable=t.gridProps.resizable||!1,x.current.columns=t.columnsRef,x.current.columnsState=b.cloneArray(t.columnsState),k.current.reorderable=t.gridProps.reorderable||!1,k.current.groupable=He,k.current.columns=t.columnsRef,k.current.dir=ve,St(),a.createElement(Vt.GridContext.Provider,{value:{isClient:I,rowReorder:F,activeDragRowDataItemRef:W,reorderRowDragTargetRef:kt,reorderRowDropTargetRef:Kt,dir:ve,getCellPositionStyle:xt,dataItemKey:t.gridProps.dataItemKey,columnsState:t.columnsState,columnsRef:t.columnsRef,onColumnsStateChange:ae,groupChange:ie,selectionRelease:nt,pagerPageChange:ut,onContextMenu:qe,rowClick:je,rowDblClick:_e,cellClick:Je,headerCellClick:Se,itemChange:Ze,onDialogEditCancel:Xe,onDialogEditSubmit:$e,sortable:t.gridProps.sortable,sort:t.gridProps.sort,defaultSort:t.gridProps.defaultSort,sortChange:xe,filterable:t.gridProps.filterable,filter:t.gridProps.filter,defaultFilter:t.gridProps.defaultFilter,filterOperators:t.gridProps.filterOperators||Wt.operators,filterChange:gt,searchChange:ft,exportAsPdf:oe,onHeaderSelectionChange:tt,columnGroupChange:ht,onKeyDown:Ve,onFocus:We,scrollHandler:Ue,selectionChange:pe,mobileMode:Tt,adaptiveColumnMenuRef:ne.current,adpativeTitle:t.gridProps.adaptiveTitle,adaptive:t.gridProps.adaptive,dispatchDetailExpand:Ye,dispatchGroupExpand:Qe,columnResizeRef:x,dragLogicRef:k,navigationStateRef:G,tableElementRef:M,tableBodyElementRef:O,headerElementRef:Dt,containerElementRef:q,headTableElementRef:se,elementRef:T,virtualScrollHeightContainerRef:Ae,footerRef:U,headerRef:V,vsRef:P}},a.createElement(d.TableKeyboardNavigationContext.Provider,{value:K.current},t.children),a.createElement(qt.GridContextMenu,{show:g.show&&($==null?void 0:$.length),dataItem:g.dataItem,field:g.field,items:$,offset:g.offset,onClose:Ee,onSelect:Ne}),t.gridProps.pdf&&a.createElement(Ut.BasePDFExport,{gridProps:t.gridProps,innerGrid:t.innerGrid,pdf:typeof t.gridProps.pdf=="object"?t.gridProps.pdf:{},onPdfExport:mt,ref:e=>Ie.current=e}))};exports.GridClientWrapper=jt;
